/*	$Csoft	    */

/*
 * Copyright (c) 1999, 2000, 2001 CubeSoft Communications, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistribution of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistribution in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of CubeSoft Communications, nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/types.h>
#include <sys/mman.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

#include "techmlm.h"

#ifdef ARCHIVE

static void	archive_write(struct techmlm *, char *);

static void 
archive_write(struct techmlm *ti, char *dat)
{
	int f;

	if (!ti->archive || !ti->af) {
		return;
	}

	if ((f = open(ti->af, O_WRONLY | O_CREAT, 00644)) > 0) {
		write(f, dat, strlen(dat));
		close(f);
	}
}

void 
techmlm_archive(struct techmlm * ti)
{
	int f;
	size_t fl;
	char *s;

	f = open(ti->tf, O_RDONLY, 00600);
	if (f < 0) {
		perror(ti->tf);
		return;
	}
	fl = lseek(f, 0, SEEK_END);
	if (fl < 5) {
		close(f);
		return;
	}
	s = mmap(0, fl, PROT_READ, MAP_PRIVATE, f, 0);
	close(f);

	if ((void *)s != MAP_FAILED) {
		archive_write(ti, s);
		munmap(s, fl);
	} else {
		perror("mmap");
	}
}

#endif /* ARCHIVE */
