/*	$Csoft	    */

/*
 * Copyright (c) 1999, 2000, 2001 CubeSoft Communications, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistribution of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistribution in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of CubeSoft Communications, nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <glib.h>

#include "techmlm-web.h"

static void 	index_foreach_followup_free(struct tmhead *, struct tmweb *);
static void 	index_foreach_followup(struct tmhead *, struct tmweb *);
static void	index_foreach(struct tmhead *, struct tmweb *);
void 		techmlm_web_index(struct tmweb *);

static void
index_foreach_followup_free(struct tmhead *twh, struct tmweb *twi)
{
	free_header(twh);
}

static void
index_foreach_followup(struct tmhead *twh, struct tmweb *twi)
{
	char il, *s;

	if ((s = index(twh->msgid, '.'))) {
		il = s - twh->msgid;
		if (strncmp(twi->fn, twh->msgid, il - 1))
			return;

		puts("<dd>");
		printf("<a href=\"%s/%i-%i/%s.html\">%s</a> - "
		    "(<i><a href=\"mailto:%s\">%s</a></i>)",
		    twi->baseurl, twi->mon, twi->year, twh->msgid,
		    twh->subject, twh->from, twh->from);
	}
}

static void
index_foreach(struct tmhead *twh, struct tmweb *twi)
{
	puts("<dl><dt>");
	printf("<a href=\"%s/%i-%i/%s.html\">%s</a> - "
	       "(<i><a href=\"mailto:%s\">%s</a></i>)\n",
	    twi->baseurl, twi->mon, twi->year, twh->msgid,
	    twh->subject, twh->from, twh->from);

	strncpy(twi->fn, twh->msgid, MAX_MSGIDLEN);
	g_slist_foreach(twi->followups, (GFunc) index_foreach_followup, twi);
	puts("</dl>");
	free_header(twh);
}

void 
techmlm_web_index(struct tmweb *twi)
{
	time_t mclock;
	char *s, *s2;

	mclock = time(NULL);
	s = layout_html_head_dup("techmlm archive");
	s2 = layout_html_foot_dup();

	puts(s);
	free(s);

	puts("<ul>");
	twi->headers = g_slist_reverse(twi->headers);
	twi->followups = g_slist_reverse(twi->followups);
	g_slist_foreach(twi->headers,
	    (GFunc)index_foreach, twi);
	g_slist_foreach(twi->followups,
	    (GFunc)index_foreach_followup_free, twi);
	puts("</ul>");

	puts(s2);
	free(s2);
	puts("<p align=\"right\">Last update on <i>");
	puts(ctime(&mclock));
	puts("</body></html>");
}

