/*	$Csoft	    */

/*
 * Copyright (c) 1999, 2000, 2001 CubeSoft Communications, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistribution of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistribution in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of CubeSoft Communications, nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <glib.h>

#include "techmlm-web.h"

char		*layout_html_head_dup(char *);
char		*layout_html_foot_dup(void);
static void	 layout_write_header(struct tmweb *, struct tmhead *, int);
void 		 layout_html(struct tmweb *, int, char *, size_t,
		     struct tmhead *);

char *
layout_html_head_dup(char *title)
{
	return (g_strdup_printf(
"<html><head><title>%s</title></head>
<body bgcolor = \"#000000\" text=\"#ffffff\" link=\"#c0c0c0\"
 vlink=\"#c0c0c0\" alink=\"#c0c0c0\"><br><p><h2>%s</h2><hr><p><center>
<table border = \"0\" width=\"80%c\"><tr><td>",
	    title, title, '%'));
}

char *
layout_html_foot_dup(void)
{
	return (g_strdup_printf("</td></tr></table></center><br><hr>"));
}

static void 
layout_write_header(struct tmweb *twi, struct tmhead *twh, int fd)
{
	char *s1, *s2;
	
	s1 = layout_html_head_dup(twh->subject);
	s2 = g_strdup_printf("
<table border = \"0\" cellspacing=\"2\" cellpadding=\"1\">
<tr>
 <td><font size=\"2\">From:</td>
 <td><font size=\"2\"><a href=\"mailto:%s\">%s</a></td>
</tr>
<tr>
 <td><font size=\"2\">To:</td>
 <td><font size=\"2\"><a href=\"mailto:%s\">%s</a></td>
</tr>
<tr>
<td><font size=\"2\">Date:</td><td><font size=\"2\"><i>%s</i></td>
</tr>
<tr>
<td><font size=\"2\">Subject:</td><td><font size=\"2\"><b>%s</b></td>
</tr>",
	twh->from, twh->from, twh->to, twh->to, twh->date, twh->subject);

	write(fd, s1, strlen(s1));
	write(fd, s2, strlen(s2));

	free(s1);
	free(s2);
}

void 
layout_html(struct tmweb *twi, int fd, char *s, size_t fl, struct tmhead *twh)
{
	char *s1, *s2, *s3;

	layout_write_header(twi, twh, fd);
	s1 = g_strdup_printf(
"<tr><td></td><td><br><p>
<pre><font face = \"clean,helvetica\" size=\"4\">%s</pre></td></tr></table>",
	    twh->data);
	s2 = layout_html_foot_dup();
	s3 = strdup("</body></html>");

	write(fd, s1, strlen(s1));
	write(fd, s2, strlen(s2));
	write(fd, s3, strlen(s3));

	free(s1);
	free(s2);
	free(s3);
}

