/*	$Csoft	    */

/*
 * Copyright (c) 1999, 2000, 2001 CubeSoft Communications, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistribution of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistribution in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of CubeSoft Communications, nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _TECHMLM_WEB_H_
#define _TECHMLM_WEB_H_

#include "techmlm.h"

#ifndef DEFAULT_ARDIR
#define DEFAULT_ARDIR "list.ar"
#endif

struct tmweb {
	char	*ardir;
	char	*wwwdir;
	char	*baseurl;
	char	 fn[MAX_MSGIDLEN];
	int	 mon;
	int	 year;
	size_t	 maxmsglen;
	GSList	*headers;
	GSList	*followups;
};

struct tmhead {
	char	*from;
	char	*to;
	char	*subject;
	char	*date;
	char	*msgid;
	char	*data;
	char	 depth;
	char	 added;
};

void	 layout_html(struct tmweb *, int, char *, size_t, struct tmhead *);
char	*layout_html_head_dup(char *);
char	*layout_html_foot_dup(void);

void 	 techmlm_web_index(struct tmweb *);
void	 free_header(struct tmhead *);

struct tmhead	*parse_header(struct tmweb *, char *, size_t, char *);

#endif /* !_TECHMLM_WEB_H_ */
