/*	$Csoft	    */

/*
 * Copyright (c) 1999-2001 CubeSoft Communications, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistribution of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistribution in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of CubeSoft Communications, nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _TECHMLM_H_
#define _TECHMLM_H_

#include "config.h"

#include <sys/types.h>

#ifndef DEFAULT_LOGFILE
#define DEFAULT_LOGFILE "list.log"
#endif

#ifndef DEFAULT_ARDIR
#define DEFAULT_ARDIR "list.ar"
#endif

#ifndef DEFAULT_BASEURL
#define DEFAULT_BASEURL "http://localhost"
#endif

#ifndef DEFAULT_MTA
#define DEFAULT_MTA "/var/qmail/bin/qmail-inject"
#endif

#ifndef DEFAULT_TMPDIR
#define DEFAULT_TMPDIR "tmp"
#endif

#ifndef DEFAULT_LISTFILE
#define DEFAULT_LISTFILE "list"
#endif

#ifndef BUFSIZE
#define BUFSIZE 4096
#endif

#ifndef MAX_LENGTH
#define MAX_LENGTH (64*1048576)
#endif

#ifndef MAX_MSGIDLEN
#define MAX_MSGIDLEN 128
#endif

#define CAT_CMD "/bin/cat"

#define S_FAIL 0
#define S_OK 1
#define S_DEFER 2

#define D_FAIL 0
#define D_OK 1
#define D_FATAL 2

#define L_ERROR 0
#define L_OK 1
#define L_WARN 2
#define L_INFO 3

typedef char *	msgid_t;
typedef char *	case_t;

#ifdef USE_QMAIL
struct qmail_env {
	char	*sender;
	char	*newsender;
	char	*recipient;
 	char	*host;
	char	*local;
};
#endif

struct techmlm {
	char	*tf, *lf, *af, *cf, *logfile, *email;
	char	*ardir, *ciddir;
	char	defer, archive, tamperwith, replyto;
	char	mon, mday, sec, min, hour;
	short	int year;
	size_t	totlen;
	msgid_t	msgid;
	case_t	casetype, cid;
#ifdef USE_QMAIL
 	struct	qmail_env qi;
#endif
};

void	techmlm_tamperwith(struct techmlm *);
char	techmlm_deliver(struct techmlm *);
void	techmlm_archive(struct techmlm *);
void	qmail_getenv(struct techmlm *);

msgid_t	msgid(struct techmlm *);
void	log(struct techmlm *, char, char *, ...);
void	regetdate(struct techmlm *);
char	*occurc(char *, char);
char	*chopc(char *, char);

#endif /* !_TECHMLM_H_ */
